-module(login).

-include_lib("kvs/include/feed.hrl").
-include_lib("nitro/include/nitro.hrl").
-include_lib("n4u/include/wf.hrl").


-export([
  main/0,
  event/1
]).


main() ->
  #dtl{file = "login", app = n2o_sample, bindings = [
    {body, body()},
    {folders, folders()}
  ]}.

folders() -> string:join([filename:basename(F) || F <- filelib:wildcard(code:priv_dir(n2o_sample) ++ "/snippets/*/")], ",").

body() ->
 [#span  { id = "display" },               #br{},
  #span  { body = "Login: " },             #textbox{id = "user", autofocus = true}, #br{},
  #span  { body = "Join/Create Feed: " },  #textbox{id = "pass"},
  #button{ id = "loginButton", body = "Login", postback = login, source=[user, pass]} ].

event(login) ->
  User = case wf:q(user) of
    <<>> -> "anonymous";
    undefined -> "anonymous";
    E -> wf:to_list(E)
  end,
  wf:user(User),
  wf:info(?MODULE, "User: ~p", [wf:user()]),
  wf:redirect("index.html?room=" ++ wf:to_list(wf:q(pass))),
  ok;

event(_) -> [].

