-module(n2o_sample_sup).

-behaviour(supervisor).

%%-include_lib("kvs/include/user.hrl").


-export([
  start_link/0,
  init/1
]).


start_link() ->
  supervisor:start_link({local, ?MODULE}, ?MODULE,[]).


%-define(USERS, [ #user{id = "maxim",  email = "maxim@synrc.com"},
%                 #user{id = "doxtop", email = "doxtop@synrc.com"},
%                 #user{id = "roman",  email = "roman@github.com"} ]).


init([]) ->
%  users:init(),            %% todo check debug rest on erl24
%  users:populate(?USERS),
  kvs:join(),
  
  Params = #{host => application:get_env(n4u, pgs_host, "localhost"), %% gets settings from sys.config
    port => application:get_env(n4u, pgs_port, 6432),                 %% and start postgresql connections pool
    username => application:get_env(n4u, pgs_user, "user"),
    password => application:get_env(n4u, pgs_pass, "pass"),
    database => application:get_env(n4u, pgs_db, "test")},
  
  case epgsql_pool:start(my_main_pool, 10, 50, Params) of
    {ok, _} ->
      io:format("~p~n", ["pg_pool start !!"]),
      ok;
    Err ->
      io:format("Pool start err: ~p~n~p~n", ["err db connect", Err]),
      err
  end,
  
  Dispatch = n2o_sample_app:routes(),
  cowboy:start_clear(http, [{port, application:get_env(n4u, port, 8000)}], #{env => #{dispatch => Dispatch}}),
  
  {ok, {{one_for_one, 10, 10}, []}}.

